//dynip.js
//Dynamique Domaine Ip Updater pour NodeJs
//Bud 'Robert' Spencer 04/2016 - Update 10/2017

var dns = require ('dns');
var request = require('request');
var events = require('events');

module.exports = function DynIp(name){	
	var name = name;
	
	var result = {
		publicip : '',
		domainip : '',
		resupdate : '',
		timecheck : '',
		timeupdate : '',
		running : false
	};	
		
	var config = {     
		domain : '',
		urlupdate : '',
		urlip : '',
		interval : 0
	};
  
	var auth = {
		user : '',
		password : '' 
	};
		
	var timer = null;	
    var dynipEvent = new events.EventEmitter();
	
	this.event = dynipEvent;
	this.name = name;
	this.config = config;		
	this.auth = auth;	
	this.result = result;
				
	
	this.run = function() {
		if(!timer)
		{
			if (config.interval < 1) {
				return;
			}
			timer = setInterval(this.check,config.interval * 60000);
			result.running=true;
			this.check();
		}
	}
	
	this.stop = function() {
		if(timer) {
			clearInterval(timer);
			timer= null;
			result.running=false;
			this.check();
		}
	}

	
	this.check = function() {
		if (config.urlip.trim() == '') {
			dynip_UpdateDomainIp('');
		}
		else {
			dynip_CheckIps();
		}
	}


	function dynip_CheckIps() {		  		
		result.timecheck = new Date().toLocaleString();
		dns.lookup(config.domain,4,function onLookup(error,address,family) {
			if(!error) {
				result.domainip = address;				
				request({url: 'http://' + config.urlip},function(error,response,body) {
					if(!error && response.statusCode == 200) {
						result.publicip = JSON.parse(body).ip;
						if(result.publicip != result.domainip) {
							dynip_UpdateDomainIp(result.publicip);
						}
					}
					else {
						result.publicip = 'Error get public IP';
					}				
				});		
			}	
			else {
				result.domainip = 'Error get dyn domain IP';
			}
			dynipEvent.emit(name, result,config);
		});	
	}


	function dynip_UpdateDomainIp(ip) {
		var nlc  = '';
		if (ip != '') {
			nlc = '&myip=' + ip 
		}
		
		result.timeupdate = new Date().toLocaleString();		
		
		url = 'https://' + auth.user + ':' + auth.password + 
			'@' + config.urlupdate + '/nic/update?system=dyndns&' +
			'hostname=' + config.domain +
			nlc +
			'&wilcard=no';

		request({url: url},function(error,response,body) {
			if(!error && response.statusCode == 200) {
				result.resupdate = body;
			}
			else {
				result.resupdate = 'Error dyn domain update';
			}
			dynipEvent.emit(name, result,config);
		});	
	}
};
